<script setup>
  import { ref, inject } from 'vue'
  import { useRouter  } from 'vue-router'
  const axios = inject('axios')
  const username = ref("")
  const password = ref("")
  const email = ref("")
  
  const registerResponse = ref()
  const minUsername = 6
  const minPassword = 6

  const router = useRouter()

function parseJwt (token) {
    var base64Url = token.split('.')[1];
    var base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');
    var jsonPayload = decodeURIComponent(window.atob(base64).split('').map(function(c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));

    return JSON.parse(jsonPayload);
}

  function isValidateEmail(email){
    return String(email)
    .toLowerCase()
    .match(
      /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
    );
  }

  function minLen(str,min){
    return str.length < min
  }


  function registerUser(){
    if (minLen(username.value,minUsername) || minLen(password.value,minPassword) || !isValidateEmail(email.value)){
      return
    }

    axios.post('register',{
      params:{
        email:email.value,
        username:username.value,
        password:password.value
      }})
      .then(function(response){
        if(response.status === 200){
          registerResponse.value = response.data 
          
        }
        if(registerResponse.value.status === 200 ){
            
          localStorage.setItem("jwt", registerResponse.value.jwt_token)
          const user_id = parseJwt(registerResponse.value.jwt_token).user_id
          localStorage.setItem("user_id", user_id)
            axios.get(`user/${localStorage.getItem("user_id")}/${localStorage.getItem("jwt")}`).then(
               function(response){
                 if(response.status === 200){
                  
                   localStorage.setItem("username", response.data[0].username)
                   localStorage.setItem("role", response.data[0].role)
                   router.push('/' + response.data[0].username)
                   }
               }
             ) 
          }
        })
  }
</script>

<template>
  <header class="bg-gray-800">
    <div class="mx-auto max-w-7xl px-4 py-6 sm:px-6 lg:px-8">
      <h1 class="text-3xl font-bold tracking-tight text-white text-center">Registration</h1>
    </div>
  </header>
    <div class="flex min-h-full flex-col justify-center px-6 py-20 lg:px-8">
  <div class="sm:mx-auto sm:w-full sm:max-w-sm">
    <h2 class="mt-10 text-center text-2xl font-bold leading-9 tracking-tight text-gray-900">Register your account</h2>
  </div>
  
  <div class="mt-10 sm:mx-auto sm:w-full sm:max-w-sm">
    <p v-if="registerResponse" class="text-sm leading-6 text-red-600 text-center">{{registerResponse.message}}</p>
    <form class="space-y-6" action="#" method="POST">
        <div>
          
        <label for="username" class="block text-sm font-medium leading-6 text-gray-900">Username</label>
        <div class="mt-2">
          <input v-model="username" id="username" name="username"  autocomplete="email" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
          <p v-if="minLen(username,minUsername)" class="text-sm leading-6 text-red-600">Username to short</p>
        </div>
      </div>
      <div>
        <label for="email" class="block text-sm font-medium leading-6 text-gray-900">Email address</label>
        <div class="mt-2">
          <input v-model="email" id="email" name="email" type="email" autocomplete="email" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
        </div>
        <p v-if="!isValidateEmail(email)" class="text-sm leading-6 text-red-600">Invalid Email</p>
      </div>

      <div>
        <div class="flex items-center justify-between">
          <label for="password" class="block text-sm font-medium leading-6 text-gray-900">Password</label>
        </div>
        <div class="mt-2">
          <input v-model="password" id="password" name="password" type="password" autocomplete="current-password" required class="block w-full rounded-md border-0 py-1.5 text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-gray-400 focus:ring-2 focus:ring-inset focus:ring-indigo-600 sm:text-sm sm:leading-6">
        </div>
        <p v-if="minLen(password,minPassword)" class="text-sm leading-6 text-red-600">Password to short</p>
      </div>
    </form>
    <div class="mt-4">
        <button @click="registerUser" class="flex w-full justify-center rounded-md bg-indigo-600 px-3 py-1.5 text-sm font-semibold leading-6 text-white shadow-sm hover:bg-indigo-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-indigo-600">Sign in</button>
      </div>
    <p class="mt-10 text-center text-sm text-gray-500">
               Already a member?
               <RouterLink to="/login" class="font-semibold leading-6 text-indigo-600 hover:text-indigo-500">Login</RouterLink>
            </p>
  </div>
</div>
</template>